part of 'vrchat_dart.dart';

/// Shared code between the web and native implementations
abstract class VrcApiBase {
  /// Access to the raw generated API
  final VrchatDartGenerated rawApi;

  /// Access to auth convenience methods
  final Auth auth;

  /// DO NOT INSTANTIATE
  VrcApiBase(this.rawApi) : this.auth = Auth(rawApi);

  /// Fetch an API key. This is required for most calls to succeed.
  Future<VrcResponse> fetchApiKey() async {
    try {
      final response = await rawApi.getSystemApi().getConfig();
      rawApi.setApiKey('vrcApiKey', response.data?.apiKey ?? '');
    } on DioError catch (error) {
      return VrcResponse(error: VrcError.fromDioError(error));
    }

    return VrcResponse();
  }
}
