import 'package:dio/dio.dart';
import 'package:dio_cookie_manager/dio_cookie_manager.dart';
import 'package:cookie_jar/cookie_jar.dart';
import 'package:vrchat_dart/vrchat_dart.dart';
import 'package:vrchat_dart_generated/vrchat_dart_generated.dart';

/// Native implementation of the API
class VrcApi extends VrcApiBase {
  /// DO NOT INSTANTIATE
  VrcApi({String? cookiePath, required Dio dio})
      : super(
          VrchatDartGenerated(
            dio: dio,
            interceptors: [
              CookieManager(
                PersistCookieJar(
                  storage: FileStorage(cookiePath),
                ),
              ),
            ],
          ),
        );
}
